package com.ruoyi.platform.mapper;

import com.ruoyi.platform.domain.Dataset;
import com.ruoyi.platform.domain.Experiment;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * (Experiment)表数据库访问层
 *
 * @author makejava
 * @since 2023-11-07 15:08:21
 */
public interface ExperimentDao {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    Experiment queryById(Integer id);

    /**
     * 查询指定行数据
     *
     * @param experiment 查询条件
     * @param pageable   分页对象
     * @return 对象列表
     */
    List<Experiment> queryAllByLimit(@Param("experiment") Experiment experiment, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param experiment 查询条件
     * @return 总行数
     */
    long count(@Param("experiment") Experiment experiment);

    /**
     * 新增数据
     *
     * @param experiment 实例对象
     * @return 影响行数
     */
    int insert(@Param("experiment") Experiment experiment);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<Experiment> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<Experiment> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<Experiment> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(List<Experiment> entities);

    /**
     * 修改数据
     *
     * @param experiment 实例对象
     * @return 影响行数
     */
    int update(Experiment experiment);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);

    List<Experiment> queryByExperiment(@Param("experiment") Experiment experiment);

    Experiment findByName(@Param("name") String name);

}

